#!/usr/bin/perl
#============================================================================#
# Program Name - Sepal's GUESTBOOK v3.0                                      # 
# Programer - Kim se youn (madgf@hanmail.net)                                #
# Homepage - http://sepal.woorizip.com or http://www.spfamily.com			 #
# Last Modified - 2000.06.06                                                 #
#                                                              made in Korea #
#============================================================================#

#[ ʱ⼳ ]=================================================================#
$guest_dir = ".";                    #id丮 ִ 丮 
$cgi_url = "./spguest.cgi";          # cgi URL
$skin_url = "./skin";				 #skin 丮 URL			 	
$prog_name = "Sepal's GUESTBOOK v3.0"; #α׷ .
$sendmail = "/usr/sbin/sendmail";     #sendmail ġ
#============================================================================#

umask(000);
&parse;

sub parse{
	if($ENV{'REQUEST_METHOD'} eq "GET") {
		$buffer = $ENV{'QUERY_STRING'};
    } 
	else {
        read( STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
    }

    @pairs = split(/&/,$buffer);

	foreach $pair( @pairs ) {
        my($name,$value)=split(/=/,$pair);
        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;

		unless (($name eq 'comments') || ($name eq 'html_up') || ($name eq 'html_down')) {
			$value =~ s/<([^>]|\n)*>//g;
		}

        $FORM{$name} = $value;
    }

	&select_act;
}

sub select_act{
	if($FORM{'id'} ne ""){
		$main_dir = "$guest_dir/id/$FORM{'id'}";
		&get_conf;
		$skin = $FORM{'skin'} if($FORM{'skin'} ne "");
		$skin_dir = "$guest_dir/skin/$skin";
		$img_url = "$skin_url/$skin/img";
		$page = ($FORM{'page'} eq "") ? "1" : "$FORM{'page'}";

		$input_style = "style=\"background-color:#ffffff;border:1 solid #333333;height:19\"";		
	}
	else{
		&err("id");
	}

	my ($act) = $FORM{'action'};

	if($act eq ""){
		&display;
	}
	elsif($act eq "write_form"){
		&write_form;
	}
	elsif($act eq "write"){
		&write;
	}
	elsif($act eq "admin_login"){
		&chk_pwd("admin_login");
	}
	elsif($act eq "admin_form"){
		&admin_form;
	}
	elsif($act eq "conf_cfg"){
		&conf_cfg;
	}
	elsif($act eq "delete"){
		&chk_pwd("delete");
	}
	elsif($act eq "del_gul"){
		&del_gul;
	}
	elsif($act eq "reply"){
		&write_form;
	}
	elsif($act eq "modify"){
		&modify_form;
	}
	elsif($act eq "view_hidden"){
		&chk_pwd("hidden");
	}
	elsif($act eq "view_ok"){
		&view_ok;
	}
	elsif($act eq "search"){
		&search;
	}
	else{
		&display;
	}
}

sub get_conf{
	if(-e "$main_dir/conf.cgi"){
		open(CONF,"$main_dir/conf.cgi");
		$conf_list = <CONF>;
		close(CONF);
		@conf = split(/\|/,$conf_list);
		$admin_pwd = $conf[1];
		$skin = $conf[2];
		$left_right = $conf[3];
		$margin = $conf[4];
		$list_num = $conf[5];
		$max_data = $conf[6];
		$bgcolor = $conf[7];
		$bgimage = $conf[8];
		$width = $conf[9];
		$font_kind = $conf[10];
		$font_size = $conf[11];
		$font_color = $conf[12];
		$link_color = $conf[13];
		$mail_opt = $conf[14];
		$admin_mail = $conf[15];
		$admin_url = $conf[16]; 
		$mail_subject = $conf[17];
		$mail_comment = $conf[18];
		$gohome = $conf[19];
		$gohome_target = $conf[20];
		$reply_opt = $conf[21];
		$num_color = $conf[22];
		$home_btn = $conf[23];
	}
	else{
		my ($default_pass) = "1234";
		$admin_pwd = crypt($default_pass,"sp");
		$skin = "default";
		$left_right = "center";
		$margin = "20";
		$list_num = "10";
		$max_data = "100000";
		$bgcolor= "#ffffff";
		$bgimage = "";
		$width = "600";
		$font_kind = "";
		$font_size = "9pt";
		$font_color = "#292929";
		$link_color = "#3673FF";
		$mail_opt = "no";
		$admin_mail = "yourmail\@yourhome.net";	
		$admin_url = "http://yourhome.net";
		$mail_subject = "Ͽ   ּ...";
		$mail_comment = "湮 մԵ鿡 ϴ  ּ\n\n...^.^...";
		$gohome = "http://yournhome.net/main.htm";
		$gohome_target = "_parent";
        $reply_opt = "no";
		$num_color = "#FF1769";
		$home_btn = "no";
		mkdir("$main_dir",0777);
		mkdir("$main_dir/data",0777);
		
		open(UP, ">$main_dir/up.htm");
		print UP "<center><br><br>  Դϴ...<br><br>ʱ  1234 Դϴ...<br><br></center>";
		close(UP);

		&put_conf;
	}
}

sub put_conf{
	open(CONF, ">$main_dir/conf.cgi");
	print CONF "^.^|$admin_pwd|$skin|$left_right|$margin|$list_num|$max_data|$bgcolor|$bgimage|$width|$font_kind|$font_size|$font_color|$link_color|$mail_opt|$admin_mail|$admin_url|$mail_subject|$mail_comment|$gohome|$gohome_target|$reply_opt|$num_color|$home_btn||||||^.^";
	close(CONF);
}

sub tbl_print{
	my(@list, @gul, @gul_data, $pre_next, $main_face, $prev_pg, $next_pg, $prev_val, $next_val, $search_val, $total_num, $get_date);
	$prev_pg= $page - 1;
	$next_pg = $page + 1;
	
	$search_val = $FORM{'category'} ? "&action=search&category=$FORM{'category'}&keyword=$FORM{'keyword'}&start_num=$FORM{'start_num'}" : "";

	$prev_val = (($prev_pg > 0) && ($total_page ne "1")) ? "<a href=$cgi_url?id=$FORM{'id'}&page=$prev_pg$search_val><img src=$img_url/prev.gif border=0 alt=\" \"></a>" : "<img src=$img_url/prev.gif border=0 alt=\"  ù Դϴ.\">";
	$next_val = (($next_pg > 0) && ($total_page ne "$page")) ? "<a href=$cgi_url?id=$FORM{'id'}&page=$next_pg$search_val><img src=$img_url/next.gif border=0 alt=\" \"></a>" : "<img src=$img_url/next.gif border=0 alt=\"   Դϴ.\">"; 
	$total_num = $list_cnt;
	
	&chk_skindir;
	
	print "<script language=\"javascript\">\n";
	print "function buildArray() {\n";
	print "var a = buildArray.arguments;\n";
	print "for (i=0; i<a.length; i++) {\n";
	print "this[i] = a[i];}\n";
	print "this.length = a.length;}\n";
	print "var list1 = new buildArray(\"\",\n";
	for (0..$#skin){
		print "\"$cgi_url?id=$FORM{'id'}&skin=$skin[$_]&page=$page\"";
		if($_ ne $#skin){ print ",\n";}else{print ");\n";}
	}
	print "function go(which, num, win) {\n";
	print "n = which.selectedIndex;\n";
	print "if (n != 0) {var url = eval(\"list\" + num + \"[n]\")\n";
	print "if (win) {openWindow(url);}\n";
	print "else{location.href = url;}}}\n";
	print "</script>\n";

	print "<div align=center><table width=$width border=0 cellpadding=2 cellspacing=0><tr><td align=right>\n";
	
	print "<form name=design><select name=design_sel onChange=\"go(this, 1, false)\">\n";
	print "<option> \n";
	for(0..$#skin){
		print "<option value=$skin[$_]>$design_name[$_]\n";
	}
	print "</select>\n";
	print "</td></tr></table></div>\n";
	my $gul_cmt = ($FORM{'action'} ne "search") ? "Ƹٿ  ־" : " ˻Ǿϴ.";
	print <<__GHEAD__; #==============================  κ ^.^ 
		<div align=center>
		<table border=0 width=$width cellpadding=0 cellspacgin=0>
		<tr><td colspan=2 align=center><font color=#474747><font color=$num_color><b>$list_cnt</b></font> $gul_cmt... (<font color=$num_color>$page</font>/<font color=#3864FF>$total_page</font> Page)</font></td></tr>
		<tr><td><a href=$cgi_url?id=$FORM{'id'}&action=write_form><img src="$img_url/write.gif" border=0 alt="۳"> <a href=$cgi_url?id=$FORM{'id'}&action=admin_login><img src=$img_url/admin.gif border=0 alt=\"  մϴ.\"></a></td><td align=right>$prev_val &nbsp; $next_val</td></tr>
		</table>
		</div>
		<br>
__GHEAD__

	if(($ary[0] eq "") && ($page eq "1")){
		my($no_msg) = ("$FORM{'category'}") ? "^.^ ãô  !" : "^.^ ϵ  ϴ. ^.^";
		print "<center>$no_msg</center><br><br>\n";
	}
	else{
		&view_article;
	}
}

sub view_article{
	my(@gul, @gul_data, $name, $home, $html, $auto_link, $br_val, $subject, $comment, $open_val, $ip_data, $log_date, $mail_val, $home_val, $wdate, $pdate, $mod_date);
	my($start, $end, $no_data, $get_date);
	$start = ($FORM{'action'} eq "view_ok") ? 0 : $list_num*($page - 1);
	$end = ($FORM{'action'} eq "view_ok") ? 0 : $start + $list_num - 1;
	$no_data = $list_cnt - (($page-1)*$list_num);

	&get_date;
	$main_face = "$skin_dir/main_face.htm";
	open(TBL, "$main_face");
	@tbl = <TBL>;
	close(TBL);
	for($start..$end){
		my($num) = ($FORM{'action'} eq "view_ok") ? "$FORM{'gul'}" : "$ary[$_]";
		last if($num eq "");
		my(@tmp_tbl, $table, $reply_list);
		@tmp_tbl = @tbl;
		open(GUL, "$main_dir/data/$num");
		@gul = <GUL>;
		close(GUL);
		if($gul[1] ne ""){ #亯Ʈ .... ^.^
			my $reply_face = "$skin_dir/reply_face.htm";
			open(RETBL, "$reply_face");
			my @reply_tbl = <RETBL>;
			close(RETBL);
			for(1..$#gul){
				next if(($FORM{'ans'} ne $_) && ($FORM{'action'} eq "view_ok") && ($FORM{'ans'} ne "")); # 亯...
				my(@tmp_tbl, @gul_data, $name, $home, $html, $auto_link, $br_val, $subject, $comment, $open_val, $ip_data, $log_date, $mail_val, $home_val, $wdate, $pdate, $mod_date);
				my $no_data = "$_° 亯";
				@tmp_tbl = @reply_tbl;
				@gul_data = split(/\|/, "$gul[$_]");
				$name= $gul_data[1]; 
				$mail = $gul_data[2]; 
				$home = $gul_data[3]; 
				$html = $gul_data[4];
				$auto_link = $gul_data[5];
				$br_val = $gul_data[6];
				$subject = $gul_data[7]; 
				$comment = $gul_data[8];
				$open_val = $gul_data[9];
				$ip_data = $gul_data[10];
				$log_date = $gul_data[11];
				$mod_date = "Ͻ $gul_data[12]";
				$mail_val = ($mail eq "") ? "" : "<a href=mailto:$mail><img src=$img_url/mail.gif border=0 alt=\"$mail\"></a>";
				$home_val = ($home eq "") ? "" : "<a href=$home target=_blank><img src=$img_url/home.gif border=0 alt=\"$home\"></a>";
		
				if ($html eq "") {
					$comment =~ s/<br>/\r\n/g;
					$comment =~ s/</&lt;/g;
					$comment =~ s/>/&gt;/g;
					$comment =~ s/\r?\n/<br>/g;
					$comment =~ s/<br>/\r\n/g if($br_val ne "on");
				}
				else{
					$comment =~ s/<br>/\r\n/g if($br_val ne "on");
					$comment =~ s/&lt;br&gt;/<br>/g;
					$comment =~ s/&lt;p&gt;/<p>/g;
				}
				
				if($FORM{'action'} eq "search"){
					my $kword = "$FORM{'keyword'}";
					$name =~ s/$kword/<B><FONT COLOR=$num_color>$kword<\/font><\/b>/g;
					$subject =~ s/$kword/<B><FONT COLOR=$num_color>$kword<\/font><\/b>/g;
					$comment =~ s/$kword/<B><FONT COLOR=$num_color>$kword<\/font><\/b>/g;
				}
				
				$wdate = substr($log_date,0,16);
				$pdate = substr($date, 0,16);
				$subject = ($wdate eq $pdate) ? "<img src=$img_url/new_ans.gif> $subject" : "$subject";

				if(($auto_link eq "on") && ($FORM{'action'} ne "search")){
					$comment =~ s/(http:\/\/)([\w\+\-\/\=\?\.\~\&]+)/<img src=$img_url\/home.gif> <a href=\"$1$2\" target=\"_blank\"><font color=$link_color>$1$2<\/font><\/a>/gi;
				#	if($NT eq "1"){
						$comment =~ s/([\w\-]+\@[\w\-+\.]+[\w\-]+)/<img src=$img_url\/mail.gif> <a href=\"mailto:$1\"><font color=$link_color>$1<\/font><\/a>/gi;
				#	}
				#	else{
				#		$comment =~ s/([\w\-]+\@[\w\-+\.]+[\w\-]+)/<img src=$img_url\/mail.gif> <a href=\"javascript:newin(400, 267, 'sendmail.cgi?name=Guest&mail=$1&prog=$sendmail&home_url=$home_url','spmail')\"><font color=$link_color>$1<\/font><\/a>/gi;			
				#	}
				}
				my $re_width = int($width*0.85); #亯 ̺  ( ̺ 85ۼƮ) ^.^
				my($modify_val, $del_val,$ans_num);
				$ans_num = $_;
				$modify_val = "<a href=$cgi_url?id=$FORM{'id'}&action=modify&gul=$num&ans=$ans_num><img src=$img_url/sm_mod.gif border=0 alt=\"ϱ\"></a>";
				$del_val = "<a href=$cgi_url?id=$FORM{'id'}&action=delete&gul=$num&ans=$ans_num&no=$no_data><img src=$img_url/sm_del.gif border=0 alt=\"ϱ\"></a>";

				foreach (@tmp_tbl){
					$_ =~ s/\.\/img/$img_url/eg;
					$_ =~ s/<!--WIDTH-->/$re_width/eo;
					$_ =~ s/<!--NUM-->/$no_data/eo;
					$_ =~ s/<!--DATE-->/$log_date/eo;

					if(($open_val ne "no") || ($view eq "ok")){					
						$_ =~ s/<!--NAME-->/$name/eo;
						$_ =~ s/<!--MAIL-->/$mail_val/eo;
						$_ =~ s/<!--HOME-->/$home_val/eo;
						$_ =~ s/<!--SUBJECT-->/$subject/eo;
						$_ =~ s/<!--COMMENT-->/$comment/eo;
						$_ =~ s/<!--IP-->/$ip_data/eo;
					}
					else{
					my($tbl_width) = $width + 40;
						$_ =~ s/<!--SUBJECT-->/"̱  Դϴ..."/eo;
						$_ =~ s/<!--COMMENT-->/"<br><br><br><center><a href=\"javascript:newin($tbl_width, 400, '$cgi_url?id=$FORM{'id'}&action=view_hidden&gul=$num&ans=$ans_num&small=ok','view')\">ƢƢ    ƢƢ<\/a><\/center>"/eo;
					}
					$_ =~ s/<!--MOD_DATE-->/$mod_date/eo if($gul_data[12] ne "");
					unless($FORM{'action'} eq "view_ok"){
						$_ =~ s/<!--MODIFY-->/$modify_val/eo;
						$_ =~ s/<!--DELETE-->/$del_val/eo;
					}
					$reply_list.=$_;
				}
			}
		}
		@gul_data = split(/\|/, "$gul[0]");
		$name= $gul_data[1]; 
		$mail = $gul_data[2]; 
		$home = $gul_data[3]; 
		$html = $gul_data[4];
		$auto_link = $gul_data[5];
		$br_val = $gul_data[6];
		$subject = $gul_data[7]; 
		$comment = $gul_data[8];
		$open_val = $gul_data[9];
		$ip_data = $gul_data[10];
		$log_date = $gul_data[11];
		$mod_date = "Ͻ $gul_data[12]";
		$mail_val = ($mail eq "") ? "" : "<a href=mailto:$mail><img src=$img_url/mail.gif border=0 alt=\"$mail\"></a>";
		$home_val = ($home eq "") ? "" : "<a href=$home target=_blank><img src=$img_url/home.gif border=0 alt=\"$home\"></a>";

		if ($html eq "") {
			$comment =~ s/<br>/\r\n/g;
			$comment =~ s/</&lt;/g;
			$comment =~ s/>/&gt;/g;
			$comment =~ s/\r?\n/<br>/g;
			$comment =~ s/<br>/\r\n/g if($br_val ne "on");
		}
		else{
			$comment =~ s/<br>/\r\n/g if($br_val ne "on");
			$comment =~ s/&lt;br&gt;/<br>/g;
			$comment =~ s/&lt;p&gt;/<p>/g;
		}
		
		if($FORM{'action'} eq "search"){
			my $kword = "$FORM{'keyword'}";
			$name =~ s/$kword/<B><FONT COLOR=$num_color>$kword<\/font><\/b>/g;
			$subject =~ s/$kword/<B><FONT COLOR=$num_color>$kword<\/font><\/b>/g;
			$comment =~ s/$kword/<B><FONT COLOR=$num_color>$kword<\/font><\/b>/g;
		}
		
		$wdate = substr($log_date,0,16);
		$pdate = substr($date, 0,16);
		$subject = ($wdate eq $pdate) ? "<img src=$img_url/new.gif> $subject" : "$subject";

		if(($auto_link eq "on") && ($FORM{'action'} ne "search")){
			$comment =~ s/(http:\/\/)([\w\+\-\/\=\?\.\~\&]+)/<img src=$img_url\/home.gif> <a href=\"$1$2\" target=\"_blank\"><font color=$link_color>$1$2<\/font><\/a>/gi;
	#		if($NT eq "1"){
				$comment =~ s/([\w\-]+\@[\w\-+\.]+[\w\-]+)/<img src=$img_url\/mail.gif> <a href=\"mailto:$1\"><font color=$link_color>$1<\/font><\/a>/gi;
	#		}
	#		else{
	#			$comment =~ s/([\w\-]+\@[\w\-+\.]+[\w\-]+)/<img src=$img_url\/mail.gif> <a href=\"javascript:newin(400, 267, 'sendmail.cgi?name=Guest&mail=$1&prog=$sendmail&home_url=$home_url','spmail')\"><font color=$link_color>$1<\/font><\/a>/gi;			
	#		}
		}

		my($reply_val, $modify_val, $del_val, $write_val);
		$reply_val = "<a href=$cgi_url?id=$FORM{'id'}&action=reply&gul=$num&no=$no_data><img src=$img_url/reply.gif border=0 alt=\"亯ޱ\"></a>";
		$modify_val = "<a href=$cgi_url?id=$FORM{'id'}&action=modify&gul=$num&ans=0><img src=$img_url/modify.gif border=0 alt=\"ϱ\"></a>";
		$del_val = "<a href=$cgi_url?id=$FORM{'id'}&action=delete&gul=$num&ans=0><img src=$img_url/delete.gif border=0 alt=\"ϱ\"></a>";
		$write_val = "<a href=$cgi_url?id=$FORM{'id'}&action=write_form><img src=$img_url/write.gif border=0 alt=\"۳\"></a>";
		
		foreach (@tmp_tbl){
			$_ =~ s/\.\/img/$img_url/eg;
			$_ =~ s/<!--WIDTH-->/$width/eo;
			$_ =~ s/<!--NUM-->/$no_data/eo;
			if(($open_val ne "no") || ($view eq "ok")){
				$_ =~ s/<!--NAME-->/$name/eo;
				$_ =~ s/<!--MAIL-->/$mail_val/eo;
				$_ =~ s/<!--HOME-->/$home_val/eo;
				$_ =~ s/<!--SUBJECT-->/$subject/eo;
				$_ =~ s/<!--COMMENT-->/$comment/eo;
				$_ =~ s/<!--IP-->/$ip_data/eo;
			}
			else{
				my($tbl_width) = $width + 40;
				$_ =~ s/<!--SUBJECT-->/"̱  Դϴ..."/eo;
				$_ =~ s/<!--COMMENT-->/"<br><br><br><center><a href=\"javascript:newin($tbl_width, 400, '$cgi_url?id=$FORM{'id'}&action=view_hidden&gul=$num&small=ok','view')\">ƢƢ    ƢƢ<\/a><\/center>"/eo;
			}
			$_ =~ s/<!--DATE-->/$log_date/eo;
			$_ =~ s/<!--MOD_DATE-->/$mod_date/eo if($gul_data[12] ne "");
			$_ =~ s/<!--REPLY_LIST-->/$reply_list/eo;
			unless($FORM{'action'} eq "view_ok"){
				$_ =~ s/<!--REPLY-->/$reply_val/eo;
				$_ =~ s/<!--MODIFY-->/$modify_val/eo;
				$_ =~ s/<!--DELETE-->/$del_val/eo;
				$_ =~ s/<!--WRITE-->/$write_val/eo;
			}
			$table.=$_;
		}
		print $table;
		print "<br><br>";
		$no_data--;	
	}
}

sub chk_skindir{
	opendir(SKIN_DIR, "$guest_dir/skin");
	@skin = sort (grep (!/^\./, readdir(SKIN_DIR)));
	closedir(SKIN_DIR);
	my $cnt = 0;
	foreach (@skin) {
		open(SKIN, "$guest_dir/skin/$_/$_.txt");
		my $txt_data = <SKIN>;
		close(SKIN);
		my @txt = split(/\|/,"$txt_data");
		$design_name[$cnt] = $txt[1];
		$cnt++;
	}
}

sub display{

#=======================================  κ =============================================
	my(@page_list, $start);
	if((-e "$main_dir/idx/$page.cgi") && ($FORM{'category'} eq "")){
		open(NUM, "$main_dir/idx/num.cgi");
		$list_cnt = <NUM>;
		close(NUM);
		if(($list_cnt eq "0") || ($list_cnt eq "")){  #------------------ ۻ Ͽ  ϳ  ʾ ...
			&read_idx;
			$list_cnt = @ary;
			$total_page = int($list_cnt/$list_num);
			if(($total_page*$list_num) < $list_cnt) {$total_page += 1;}
		}
		else{
			$total_page = int($list_cnt/$list_num);
			if(($total_page*$list_num) < $list_cnt) {$total_page += 1;}
		
			open(PAGE, "$main_dir/idx/$page.cgi");
			@page_list = <PAGE>;
			close(PAGE);
			if($page_list[0] eq "\n"){ #---------- Ǹ       ϳ ...
				$page = $page - 1;
				open(PAGE, "$main_dir/idx/$page.cgi");
				@page_list = <PAGE>;
				close(PAGE);
			}
			$start =($page-1)*$list_num;
			for(1..$list_num){
				chomp($ary[$start+$_-1] = $page_list[$_-1]);
				last if($page_list[$_] eq "\n");
			}
		}
	}
	else{
	#------------------------------------------- ε  ̿
		&read_idx;
		$list_cnt = @ary;
		$total_page = int($list_cnt/$list_num);
		if(($total_page*$list_num) < $list_cnt) {$total_page += 1; }
		$page = $total_page if("$FORM{'total_val'}"); #ۻ   Ÿ ϶...  ư   ^^
	}
	#---------------------------------------------------------
#=======================================  κ =============================================		
	&head;
	&tbl_print;
	&pagemove("$page", "$total_page");
	&find;
	&foot;
}

sub search{
	if($FORM{'keyword'} eq ""){
			&err("keyword");
	}

	my(@num_data, @gul_data, @line1, @line2, $start_num, $end_num, $search_data, $category); 
	&read_idx;
	local $all_list = @ary;
	my $gul_cnt = 0;
	my($start_num) = $FORM{'start_num'} ? "$FORM{'start_num'}" : "0";
	my($end_num) = $start_num + 999;
	for($start_num..$end_num){
		last if($ary[$_] eq "");
		$num_data[$_] = $ary[$_];
	}
	
	@ary = undef;
	
	foreach $list_data(@num_data) {
		open(LIST, "$main_dir/data/$list_data");
		@gul_data = <LIST>;
		@line =split(/\|/, $gul_data[0]);
		close (LIST);
		
		if($FORM{'category'} eq "subject") { 
			$search_data=$line[7];
		}
		elsif($FORM{'category'} eq "comment"){
			$search_data=$line[8];
		}
		elsif($FORM{'category'} eq "name"){
			$search_data=$line[1];
		}
		else{
			$category = "all";
		}
		
		foreach $read_line(@gul_data) {
			if($category eq "all"){
				$search_data=$read_line;
			}
			if($search_data =~ /$FORM{'keyword'}/i) { 
				$ary[$gul_cnt] = $list_data;
				$gul_cnt++;
				last;
			}
		}
	}

	local $total_page = int($gul_cnt/$list_num);
	if(($total_page*$list_num) < $gul_cnt) {$total_page += 1; }
	$page = $total_page if("$FORM{'total_val'}");
	
	&head;
	local @ary = sort {($b <=> $a) || ($a cmp $b)}(@ary);
	local $list_cnt = @ary;
	print "<center><b><font  class=ver9>˻</font></b> <font color=$num_color>$FORM{'keyword'}</font>&nbsp;&nbsp;&nbsp; <b><font  class=ver9>˻</font></b> <font color=$num_color>$gul_cnt</font><font class=ver9></fnot></center>\n";
	&tbl_print;
	&pagemove("$page", "$total_page");
	my($resent_num) = $start_num + 1;
	my($last_num)= $end_num + 1;
	print "<br><br>\n";
	print "<center><a href=$cgi_url?id=$FORM{'id'}><img src=$img_url/list.gif border=0 alt=\"۸ \"></a></center>\n";
	print "<center><br>ֱ <font color=$head_color><b>$resent_num</b></font> <font color=$head_color><b>$last_num</b></font> Խù Ͱ Ÿ ˻Ǿϴ.<br> 1000 Խù O Ͻø Ʒ 'search'ư ּ.</center>" if($all_list > 1000);
	&find;
	&foot;
}

sub view_ok{
	my(@data, @data_list, $gul_num, $pwd);
	open(GUL, "$main_dir/data/$FORM{'gul'}");
	@data_list = <GUL>;
	close(GUL);
	$gul_num = ($FORM{'ans'} eq "") ? "0" : "$FORM{'ans'}";
	@data = split(/\|/,"$data_list[$gul_num]");
	$pwd = crypt($FORM{'admin_pwd'}, "sp");
	if((($pwd eq $admin_pwd) || ($pwd eq $data[0])) && ($FORM{'admin_pwd'} ne "")){
		local ($view) = "ok";
		&head;
		&view_article;		
		&foot;
	}
	else{
		&err("not_owner");
	}
}

sub read_idx{
	open(INDEX, "$main_dir/idx/index.txt");
	chomp(@ary = <INDEX>);
	close(INDEX);
	if($ary[0] eq ""){
		mkdir("$main_dir/idx",0777);
		&make_idx;
	}
}

sub make_idx{
	#---------------------------ε  ( ü )------------------------
	my(@num_data,$cnt);
	opendir(READ_DIR, "$main_dir/data");
	@ary = sort {($b <=> $a) || ($a cmp $b)} grep(!/^\./, readdir(READ_DIR));
	closedir(READ_DIR);
	&lock;
	open (INDEX, ">$main_dir/idx/index.cgi");
	print INDEX join("\n",@ary);
	close(INDEX);
	&unlock;
	#---------------------------ε   ---------------------------------------------------
}

sub write_form{
	my(@gul, @tbl, $main_face, $home_val, $gul_data, $name, $open_val, $mail, $home, $home_url, $html, $auto_link, $br_val, $subject, $comment, $ip_data, $date, $mail_val, $hid_val, $rep_msg, $rep_pwd);
	&read_cookie;
	if($FORM{'action'} eq "reply"){
		open(GUL, "$main_dir/data/$FORM{'gul'}");
		$gul_data = <GUL>;
		close(GUL);
		@gul = split(/\|/,$gul_data);
		
		$name = $gul[1];
		$mail = $gul[2]; 
		$home = $gul[3]; 
		$html = $gul[4];
		$auto_link = $gul[5];
		$br_val = $gul[6];
		$subject = $gul[7]; 
		$comment = $gul[8];
		$open_val = $gul[9];
		if($open_val eq "no"){
			if($FORM{'admin_pwd'} eq ""){
				&chk_pwd("reply_hidden");
			}
			else{
				my($pwd) = crypt($FORM{'admin_pwd'}, "sp");
				unless($pwd eq $admin_pwd || $pwd eq $gul[0]){
					&err("not_owner");	
				}
			}
		}	
		$ip_data = $gul[10];
		$date = $gul[11];
		$mail_val = ($mail eq "") ? "" : "<a href=mailto:$mail><img src=$img_url/mail.gif border=0 alt=\"$mail\"></a>";
		$home_val = ($home eq "") ? "" : "<a href=$home target=_blank><img src=$img_url/home.gif border=0 alt=\"$home\"></a>";
		if ($html ne "on") {
			$comment =~ s/<br>/\r\n/g;
			$comment =~ s/</&lt;/g;
			$comment =~ s/>/&gt;/g;
			$comment =~ s/\r?\n/<br>/g;
		}
		else{
			$comment =~ s/&lt;br&gt;/<br>/g;
			$comment =~ s/&lt;p&gt;/<p>/g;
		}
		$comment =~ s/<br>/\r\n/g if($br_val ne "on");
		
		if($auto_link eq "on"){
			$comment =~ s/(http:\/\/)([\w\+\-\/\=\?\.\~\&]+)/<img src=$img_url\/home.gif> <a href=\"$1$2\" target=\"_blank\"><font color=$link_color>$1$2<\/font><\/a>/gi;
			if($NT eq "1"){
				$comment =~ s/([\w\-]+\@[\w\-+\.]+[\w\-]+)/<img src=$img_url\/mail.gif> <a href=\"mailto:$1\"><font color=$link_color>$1<\/font><\/a>/gi;
			}
			else{
				$comment =~ s/([\w\-]+\@[\w\-+\.]+[\w\-]+)/<img src=$img_url\/mail.gif> <a href=\"javascript:newin(400, 267, 'sendmail.cgi?name=Guest&mail=$1&prog=$sendmail&home_url=$home_url','spmail')\"><font color=$link_color>$1<\/font><\/a>/gi;			
			}
		}
		
		$main_face = "$skin_dir/main_face.htm";
		open(TBL, "$main_face");
		@tbl = <TBL>;
		close(TBL);	
		
		foreach (@tbl){
			$_ =~ s/\.\/img/$img_url/eg;
			$_ =~ s/<!--WIDTH-->/$width/eo;
			$_ =~ s/<!--NUM-->/$FORM{'no'}/eo;
			$_ =~ s/<!--NAME-->/$name/eo;
			$_ =~ s/<!--MAIL-->/$mail_val/eo;
			$_ =~ s/<!--HOME-->/$home_val/eo;
			$_ =~ s/<!--DATE-->/$date/eo;
			$_ =~ s/<!--SUBJECT-->/$subject/eo;
			$_ =~ s/<!--COMMENT-->/$comment/eo;
			$_ =~ s/<!--IP-->/$ip_data/eo;
			$table.=$_;
		}
		&head;
		print "<br><br><center><font color=$link_color>$name Բ  Դϴ... ^^</font></center>\n";
		print $table;


		if($reply_opt eq "yes"){
			$rep_msg = "<center><font color=$link_color>ش亯 ڸ ϰ մϴ. 亯ۼ  йȣ  Էϼ.</font></center>" ;
			$rep_pwd = "<td width=97><font color=$link_color> йȣ</font> </td><td><input type=password name=admin_pwd size=11 $input_style></td>";
		}
	}
	else{
		&head;
	}

	print "<form method=post action=$cgi_url>\n";
	print "<input type=hidden name=action value=write>\n";
    $hid_val = ($FORM{'action'} eq "reply") ? "reply" : "new";
	print "<input type=hidden name=$hid_val value=ok>\n";
	print "<input type=hidden name=id value=$FORM{'id'}>\n";
	print "<input type=hidden name=gul value=$FORM{'gul'}>\n" if($hid_val ne "new");
	print "$rep_msg<br><br>";


	my($whome_val, $button_val, $write_form, $chk_opt);
	$whome_val = ($COOKIE{'UH'} ne "") ? "$COOKIE{'UH'}" : "http://";
	$chk_opt = "<input type=checkbox name=html>html <input type=checkbox name=autolink checked>home,mail ڵũ  <input type=checkbox name=br_val checked>ڵٹٲ&nbsp;&nbsp;";
	if($open_val ne "no"){
		$chk_opt .= "<select name=open><option value=yes selected><option value=no></select>" ;
	}
	else{
		$chk_opt .= "<input type=hidden name=open value=no>";
	}
	$rep_pwd = "<td width=97><font color=$link_color> йȣ</font> </td><td><input type=password name=admin_pwd size=11 $input_style></td>" if(($hid_val eq "reply") && ($reply_opt eq "yes"));
	$button_val = "<table border=0 cellpadding=0 cellspacing=0><tr>$rep_pwd<td><input type=image src=$img_url/submit.gif alt=\"۳\" border=0></td><td>&nbsp;</td><td><a href=$cgi_url?id=$FORM{'id'}><img src=$img_url/cancel.gif alt=\"۸ ư\" border=0></a></td></tr></table>";
	
	if($FORM{'action'} ne "reply"){
		open(WFORM, "$skin_dir/write.htm");
	}else{
		open(WFORM, "$skin_dir/reply.htm");
	}
	@wform = <WFORM>;
	close(WFORM);
	
	foreach (@wform){
		$_ =~ s/\.\/img/$img_url/eg;
		$_ =~ s/<!--NAME-->/$COOKIE{'UN'}/eo;
		$_ =~ s/<!--MAIL-->/$COOKIE{'UM'}/eo;
		$_ =~ s/<!--HOME-->/$whome_val/eo;
		$_ =~ s/<!--OPTION-->/$chk_opt/eo;
		$_ =~ s/<!--BUTTON-->/$button_val/eo;
		$write_form.=$_;
	}

	print $write_form;
	print "</form>\n";
	&foot;
}

sub modify_form{
	my(@gul_data,@list, $pass, $name, $mail, $home, $home_val, $autolink, $br_val, $subject, $comments, $open_val, $html_opt, $auto_opt, $br_opt, $open_yes, $open_no, $ans);
	open(GUL,"$main_dir/data/$FORM{'gul'}");
	@gul_data = <GUL>;
	close(GUL);
	$ans = $FORM{'ans'};
	@list = split(/\|/,$gul_data[$ans]);
	
	$pass = $list[0];
	$name = $list[1];
	$mail = $list[2];
	$home = $list[3];
	$html = $list[4];
	$autolink = $list[5];
	$br_val = $list[6];
	$subject = $list[7];
	$comments = $list[8];
	$open_val = $list[9];

	$comments =~ s/<br>/\n/g;
	
	$home_val = ($home ne "") ? "$home" : "http://";
	$html_opt = "checked" if($html eq "on");
	$auto_opt = "checked" if($autolink eq "on");
	$br_opt = "checked" if($br_val eq "on");
	if($open_val eq "yes"){
		$open_yes = "selected";
	}
	else{
		$open_no = "selected";
	}	
	&head;
	print <<__MFORM__;
	<form method=post action=$cgi_url>
	<input type=hidden name=action value=write>
	<input type=hidden name=modify value=ok>
	<input type=hidden name=id value="$FORM{'id'}">
	<input type=hidden name=gul value="$FORM{'gul'}">
	<input type=hidden name=ans value="$FORM{'ans'}">
__MFORM__
	
	my $chk_opt = "<input type=checkbox name=html $html_opt>html <input type=checkbox name=autolink $auto_opt>home,mail ڵũ 						               <input type=checkbox name=br_val $br_opt>ڵٹٲ&nbsp;&nbsp;<select name=open><option value=yes $open_yes><option value=no $open_no></select>";
	my $button_val = "<table border=0 cellpadding=0 cellspacing=0><tr><td> ۼ йȣ &nbsp;</td><td><input type=password name=own_pwd size=8 $input_style></td><td><input type=image src=$img_url/submit.gif alt=\"۳\" border=0></td><td>&nbsp;</td><td><a href=$cgi_url?id=$FORM{'id'}><img src=$img_url/cancel.gif alt=\"۸ ư\" border=0></a></td></tr></table>";
	open(MFORM, "$skin_dir/modify.htm");
	@mform = <MFORM>;
	close(MFORM);
	
	foreach (@mform){
		$_ =~ s/\.\/img/$img_url/eg;
		$_ =~ s/<!--NAME-->/$name/eo;
		$_ =~ s/<!--MAIL-->/$mail/eo;
		$_ =~ s/<!--HOME-->/$home_val/eo;
		$_ =~ s/<!--SUBJECT-->/$subject/eo;
		$_ =~ s/<!--OPTION-->/$chk_opt/eo;
		$_ =~ s/<!--COMMENT-->/$comments/eo;
		$_ =~ s/<!--BUTTON-->/$button_val/eo;
		$mod_form.=$_;
	}

	print $mod_form;
	print "</form>\n";
	&foot;
	&foot;
}

sub write{
	my(@idx, @temp, @gul, $num, $num_data, $pass, $name, $mail, $home, $html, $autolink, $br_val, $subject, $comments, $open_val, $mod_date, $ans, $wdate);
	if(($FORM{'name'} eq "") || ($FORM{'subject'} eq "") || ($FORM{'comments'} eq "")){
		&err("blank");
	}

	unless(($FORM{'mail'} eq "") || ($FORM{'mail'} =~ /.*\@.*\..*/)){
		&err("mail");
	}
    $ans = $FORM{'ans'};
#--------------------------------------------- ε ߰ϱ...
	if(($FORM{'reply'} ne "ok") && ($FORM{'modify'} ne "ok")){
		open(IDX, "$main_dir/idx/index.cgi");
		chomp(@idx = <IDX>);
		close(IDX);
		@temp =split(/\./,$idx[0]);
		$num = $temp[0] + 1;
		while(-e "$main_dir/data/$num.cgi"){
			unshift(@idx,"$num.cgi");
			$num++;
		}
		unshift(@idx,"$num.cgi");
		$num_data = $#idx+1;

		if($num_data > $max_data){ #ִ Ÿ ʰ  ... ^^
			while($num_data > $max_data){ 
				unlink("$main_dir/data/$idx[$#idx]");
				pop(@idx);
				$num_data--;
			}
		}
	
		&lock;
		open(DATA, ">$main_dir/idx/index.cgi");
		print DATA join("\n",@idx);
		close(DATA);
		
		for(1..10){
			open(PAGE,">$main_dir/idx/$_.cgi");
			my $start = ($_ - 1)*$list_num;
			for(0..$list_num-1){
				print PAGE "$idx[$start+$_]\n";
			}
			close(PAGE);
		}

		open(NUM,">$main_dir/idx/num.cgi"); 
		print NUM $num_data;
		close(NUM);
		&unlock;
		$num = "$num.cgi";
		&send_mail if(($mail_opt ne "no") && ($FORM{'mail'} ne ""));
	}
	else{
		if($reply_opt eq "yes" && ($FORM{'modify'} ne "ok")){
			&err("admin") if($admin_pwd ne crypt($FORM{'admin_pwd'},"sp"));
		}
		$num = $FORM{'gul'};
	}

	$pass = crypt($FORM{'password'},"sp");
	
	if($FORM{'modify'} eq "ok"){
		open(GUL, "$main_dir/data/$num");
		@gul = <GUL>;
		close(GUL);
		my @data = split(/\|/,$gul[$ans]);
		my $own_pwd = crypt($FORM{'own_pwd'},"sp");
		&err("not_owner") if((($own_pwd ne $data[0]) && ($own_pwd ne $admin_pwd)) || ($FORM{'own_pwd'} eq ""));

		if($FORM{'password'} ne "") {
			$pass = crypt($FORM{'password'},"sp");
		}
		else{
			$pass = $data[0];
		}
		$wdate = $data[11];
	}
	
	&get_date;
	print "Set-Cookie: UN=$FORM{'name'}; expires=Sunday, 31-Dec-$nyear 12:12:12 GMT;\r\n";
	print "Set-Cookie: UM=$FORM{'mail'}; expires=Sunday, 31-Dec-$nyear 12:12:12 GMT;\r\n";
	print "Set-Cookie: UH=$FORM{'home'}; expires=Sunday, 31-Dec-$nyear 12:12:12 GMT;\r\n";
	&com124('name', 'mail', 'home', 'subject', 'comments');

	$name = $FORM{'name'};
	$mail = $FORM{'mail'};
	$home = $FORM{'home'};
	$html = $FORM{'html'};
	$autolink = $FORM{'autolink'};
	$br_val = $FORM{'br_val'};
	$subject = $FORM{'subject'};
	$comments = $FORM{'comments'};
	$open_val = $FORM{'open'};
	$ip = $ENV{'REMOTE_ADDR'};
	$domain = $ENV{'HTTP_USER_AGENT'};

	if($home eq "http://"){ $home = ""; } 
	$comments =~ s/&amp;/&amp;amp;/g;
    $comments =~ s/<br>/&lt;br&gt;/g;
	$comments =~ s/\r?\n/<br>/g;
	if($FORM{'modify'} eq "ok"){
		my $mod_date = $date;
		open(DATA, ">$main_dir/data/$num");
		for(0..$#gul) {
			if($ans eq $_){
				print DATA "$pass|$name|$mail|$home|$html|$autolink|$br_val|$subject|$comments|$open_val|$ip - $domain|$wdate|$mod_date|\n";
			}
			else{
				print DATA "$gul[$_]"; 
			}
		}
		close(DATA);
	}
	else{
		if($FORM{'reply'} eq "ok"){
			open(DATA, ">>$main_dir/data/$num");
		}
		else{
			open(DATA, ">$main_dir/data/$num");
		}
		print DATA "$pass|$name|$mail|$home|$html|$autolink|$br_val|$subject|$comments|$open_val|$ip - $domain|$date||\n";
		close(DATA);
	}
	
	&load_page;
}

sub del_gul{
	my(@data, @idx, @idx_list, @gul, $x, $num, $pwd_org, $pwd_ipt, $ans);
	open(GUL,"$main_dir/data/$FORM{'gul'}");
	@gul = <GUL>;
	close(GUL);
	$ans = $FORM{'ans'};
	@data = split(/\|/,$gul[$ans]);
	
	$pwd_org = $data[0];
	&err("not_owner") if($FORM{'admin_pwd'} eq "");
	$pwd_ipt = crypt($FORM{'admin_pwd'},"sp");
	if(($pwd_org eq $pwd_ipt) || ($admin_pwd eq $pwd_ipt)){
		if($ans ne "0"){
			open(DEL, ">$main_dir/data/$FORM{'gul'}");
			for(0..$#gul){
				next if($_ eq $ans);
				print DEL $gul[$_];
			}
			close(DEL);
		}
		else{
			unlink("$main_dir/data/$FORM{'gul'}");
		}
	}
	else{
		&err("not_owner");
	}

	if($ans eq "0"){
		#------------ε 
		open(IDX,"$main_dir/idx/index.cgi");
		chomp(@idx = <IDX>);
		close(IDX);
		
		$x=0;
		open(PIDX,">$main_dir/idx/index.cgi");
		foreach (@idx){
			next if($FORM{'gul'} eq $_);
			print PIDX "$_\n";
			$idx_list[$x] = $_;
			$x++;
		}
		close(PIDX);
		
		$num = $#idx_list + 1;
		open(NUM, ">$main_dir/idx/num.cgi");
		print NUM $num;
		close(NUM);

		for(1..10){
			open(PAGE,">$main_dir/idx/$_.cgi");
			my $start = ($_ - 1)*$list_num;
			for(0..$list_num-1){
				print PAGE "$idx_list[$start+$_]\n";
			}
			close(PAGE);
		}
	}
	&load_page;
}	

sub admin_form{
	my($pwd, $skin_val, $sel_val, $lsel, $csel, $rsel, $my, $mn, $up_val, $down_val);
	$pwd = crypt($FORM{'admin_pwd'},"sp");
	if($admin_pwd ne $pwd){
		&err("admin");
	}

	&chk_skindir;
	
	for(0..$#skin){
		$sel_val = ($skin eq "$skin[$_]") ? "selected" : "";
		$skin_val.="<option value=$skin[$_] $sel_val>$design_name[$_]\n";
	}

	if($left_right eq "center"){
		$csel = "selected";
	}
	elsif($left_right eq "left"){
		$lsel = "selected";
	}
	else{
		$rsel = "selected";
	}
	
	if($home_btn eq "yes"){
		$btn_y = "selected";
	}
	else{
		$btn_n = "selected";
	}

	if($mail_opt eq "yes"){
		$my = "selected";
	}
	else{
		$mn = "selected";
	}
	
	if($reply_opt eq "yes"){
		$ry = "selected";
	}
	else{
		$rn = "selected";
	}
	&head;
	$mail_comment =~ s/<br>/\n/g;
	$mail_comment =~ s/<p>/\n\n/g;
	
	if(-e "$main_dir/up.htm"){
		open(UPDATA,"$main_dir/up.htm");
		my @html_up = <UPDATA>;
		close(UPDATA);
		foreach $_(@html_up) {
			$_ =~ s/\r?\n/\n/g;
			$up_val .= "$_";	
		}		
	}
	
	if(-e "$main_dir/down.htm"){
		open(DNDATA,"$main_dir/down.htm");
		my @html_down = <DNDATA>;
		close(DNDATA);
		foreach $_(@html_down) {
			$_ =~ s/\r?\n/\n/g;
			$down_val .= "$_";	
		}		
	}

	print <<__ADMIN__;
	<form method=post action=$cgi_url>
	<input type=hidden name=id value=$FORM{'id'}>
	<input type=hidden name=action value=conf_cfg>
	<div align=center>
	<table width=$width border=0cellpadding=2 cellspacing=0>
	<tr><td align=right>[ĭ θ  йȣ ]<br>йȣ <input type=password name=admin_pwd01 size=10 $input_style> ٽȮ<input type=password name=admin_pwd02 size=10 $input_style></td></tr>
	<tr><td align=right>Ų <select name=skin>$skin_val</select></td></tr>
	<tr><td align=right>ġ <select name=left_right><option value=left $lsel><option value=center $csel>߾<option value=right $rsel></select></td></tr>
	<tr><td align=right> ¿  <input type=text name=margin size=4 value="$margin" $input_style></td></tr>
	<tr><td align=right> ǥ  <input type=text name=list_num size=4 value="$list_num" $input_style></td></tr>
	<tr><td align=right>ִ ۵Ÿ 差 <input type=text name=max_data size=10 value="$max_data" $input_style></td></tr>
	<tr><td align=right> <input type=text name=bgcolor size=8 value="$bgcolor" $input_style> Ǵ ̹ URL <input type=text name=bgimage size=37 value="$bgimage" $input_style></td></tr>
	<tr><td align=right>̺ <input type=text name=width size=4 value="$width" $input_style></td></tr>
	<tr><td align=right>⺻  <input type=text name=font_kind size=4 value="$font_kind" $input_style></td></tr>
	<tr><td align=right>⺻ ũ <input type=text name=font_size size=4 value="$font_size" $input_style></td></tr>
	<tr><td align=right>⺻ ڻ <input type=text name=font_color size=8 value="$font_color" $input_style></td></tr>
	<tr><td align=right>  ڻ <input type=text name=num_color size=8 value="$num_color" $input_style></td></tr>
	<tr><td align=right>ũ ڻ <input type=text name=link_color size=8 value="$link_color" $input_style></td></tr>
	<tr><td align=right>亯  <select name=mail_opt><option value=yes $my>YES<option value=no $mn>NO</select></td></tr>
	<tr><td align=right> ̸ <input type=text name=admin_mail size=23 value="$admin_mail" $input_style></td></tr>
	<tr><td align=right>Ͽ ǥõ Ȩ ּ <input type=text name=admin_url size=40 value="$admin_url" $input_style></td></tr>
	<tr><td align=right>亯   <input type=text name=mail_subject size=54 value="$mail_subject" $input_style></td></tr>	
	<tr><td align=right valign=top> <textarea name=mail_comment cols=63 rows=6>$mail_comment</textarea></td></tr>
	<tr><td align=right> Ʒ Ȩư  <select name=home_btn><option value=yes $btn_y>YES<option value=no $btn_n>NO</select></td></tr>
	<tr><td align=right>Ȩư Ŭ ̵ URL <input type=text name=gohome size=40 value="$gohome" $input_style> 
						<br>Ȩư Ŭ ̵ URL target <input type=text size=6 name=gohome_target value="$gohome_target" $input_style></td></tr>	
	<tr><td align=right> κп Ե htmlױ ( &lt;body&gt;... )</td></tr>
	<tr><td align=right valign=top> <textarea name=html_up cols=63 rows=6>$up_val</textarea></td></tr>
	<tr><td align=right> Ʒκп Ե htmlױ ( ...&lt;/body&gt; )</td></tr>
	<tr><td align=right valign=top> <textarea name=html_down cols=63 rows=6>$down_val</textarea></td></tr>
	<tr><td align=right>亯 ڸ <select name=reply_opt><option value=yes $ry>YES<option value=no $rn>NO</select></td></tr>
	</table>
	<br><br>
	<div align=center>
	<table border=0 cellpadding=0 cellspacing=0>
	<tr><td>  йȣ&nbsp; </td><td><input type=password size=10 name=admin_pwd $input_style></td><td><input type=image src=$img_url/submit.gif border=0 alt="ȯ漳 "></td><td>&nbsp;</td><td><a href=$cgi_url?id=$FORM{'id'}><img src=$img_url/cancel.gif border=0 alt=" ư"></a></td></tr>
	</table></div>
	</form>
__ADMIN__

&foot;
}

sub conf_cfg{
	my($chg_pwd);
	
	&err("admin") if($admin_pwd ne crypt($FORM{'admin_pwd'},"sp"));
	 
	if(($FORM{'admin_pwd01'} ne "") || ($FORM{'admin_pwd02'} ne "")){
		if($FORM{'admin_pwd01'} eq $FORM{'admin_pwd02'}){
			$chg_pwd = crypt($FORM{'admin_pwd01'},"sp");
		}
		else{
			&err("same_pwd");
		}
	}
	else{
		$chg_pwd = $admin_pwd;
	}

	$FORM{'mail_comment'} =~ s/\r?\n/<br>/g;

	open(CFG,">$main_dir/conf.cgi");
	print CFG "^.^|$chg_pwd|$FORM{'skin'}|$FORM{'left_right'}|$FORM{'margin'}|$FORM{'list_num'}|$FORM{'max_data'}|$FORM{'bgcolor'}|$FORM{'bgimage'}|$FORM{'width'}|$FORM{'font_kind'}|$FORM{'font_size'}|$FORM{'font_color'}|$FORM{'link_color'}|$FORM{'mail_opt'}|$FORM{'admin_mail'}|$FORM{'admin_url'}|$FORM{'mail_subject'}|$FORM{'mail_comment'}|$FORM{'gohome'}|$FORM{'gohome_target'}|$FORM{'reply_opt'}|$FORM{'num_color'}|$FORM{'home_btn'}|||||||^.^";
	close(CFG);
	
	if($FORM{'html_up'} ne ""){
		open(UP,">$main_dir/up.htm");
		print UP "$FORM{'html_up'}";
		close(UP);
	}

	if($FORM{'html_down'} ne ""){
		open(DOWN,">$main_dir/down.htm");
		print DOWN "$FORM{'html_down'}";
		close(DOWN);
	}
	
	for(1..10){
		unlink("$main_dir/idx/$_.cgi");
	}

	&load_page;
}

sub get_date{
	my @week = qw(  ȭ    );
    my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
	
	if($year < 2000){
		if($year >= 100){
			$year=($year-100)+2000;
		}
		else{
			$year=2000+$year;
		}
	}
	
	$nyear = $year+1;
	$mon = ($mon + 1);
	if ($mon < 10)  { $mon = "0$mon";   }
	if ($mday < 10) { $mday = "0$mday"; }
	if ($hour < 10) { $hour = "0$hour"; }
	if ($min < 10)  { $min = "0$min";   }
	if ($sec < 10)  { $sec = "0$sec";   }

	my $week_val = "$week[$wday]";
	if($hour <= 11){
		$hour = " $hour";
	}
	elsif($hour == 12){
		$hour = " $hour";
	}
	else{
		$hour -= 12;
		$hour = " $hour";
	}
	$date = "$year $mon $mday $week_val $hour $min"; 
}

sub load_page{
	my($search_val,$page);
	&head;
	$page = ($FORM{'page'} ne "") ? "$FORM{'page'}" : "1";
#	$search_val = "&action=search&category=$FORM{'category'}&keyword=$FORM{'keyword'}&start_num=$FORM{'start_num'}" if("$FORM{'category'}");
	print "<META HTTP-EQUIV=Refresh CONTENT=1;URL=$cgi_url?id=$FORM{'id'}&page=$page>\n";
	print "<center><p>&nbsp;<p>&nbsp;<p>&nbsp;<hr width=300 noshade>\n";
	print "<font class=ver9>Loading ......</font>\n";
	print "<hr width=300 noshade>\n";
	print "<br><br><a href=$cgi_url?id=$FORM{'id'}><font color=#FFA8E3></font><font color=#92B8FF></font> <font class=ver9> ư</font></a><p></center>\n";
	&foot;
}

#===================================  ̵ Լ ^.^  
sub pagemove{
	my($page, $total_page) = @_;
	my($search_val) = ($FORM{'action'} eq "search") ? "&action=search&category=$FORM{'category'}&keyword=$FORM{'keyword'}&start_num=$FORM{'start_num'}" : "";
	my ($sel_col, $font_col, $interval, $start, $end, $prev, $next, $next_opt, $first, $last);
	$sel_col = $num_color;
	$font_col = $font_color;

	print "<div align=center><table border=0 cellpadding=0 cellspacing=0>";
	print "<tr><td align=center class=ver9><font color=$font_col>";
	$interval = 10; 
	$start = (int(($page-1)/$interval))*$interval + 1;
	$end = $start + $interval -1;

	if($total_page <= $end){
		$end = $total_page;
		$next_opt = "no"
	}

	if($start == 1){
		print "[]...";
	}
	else{
		$prev = $start - 1;
		print "[<a href=$cgi_url?id=$FORM{'id'}&page=1$search_val><font color=$font_col>First</font></a>]";
		print "[<a href=$cgi_url?id=$FORM{'id'}&page=$prev$search_val><font color=$font_col></font></a>]...";
	}
	
	for($start..$end){
		if($page eq $_){
			print "[<font color=$sel_col><b>$_</b></font>]";
		}
		else{
			print "[<a href=$cgi_url?id=$FORM{'id'}&page=$_$search_val><font color=$font_col>$_</font></a>]";
		}
	}

	if($next_opt eq "no"){
		print "...[]";
	}
	else{
		$next = $end + 1;
		$last;
		print "...[<a href=$cgi_url?id=$FORM{'id'}&page=$next$search_val><font color=$font_col></font></a>]";
		print "[<a href=$cgi_url?id=$FORM{'id'}&page=$total_page$search_val><font color=$font_col>Last</font></a>]";
	}
	print "</font></td></tr>\n";
	print "</table></div>\n";
}

sub read_cookie{
    if($ENV{'HTTP_COOKIE'}) {
       my @cookies = split(/; /,$ENV{'HTTP_COOKIE'});
        foreach(@cookies) {
			($name,$value) = split(/=/,$_);
			$COOKIE{$name} = $value;
        }
	}
}

#--------- |   Լ... ^.^
sub com124{ 
	@com_list = @_;

	foreach $list(@com_list){
		$FORM{$list} =~ s/\|/&#124;/g;
	}
}

sub chk_pwd{
	my($msg, $act, $gul_opt, $ans_opt, $small_opt, $no_opt, $admin);
	my($cmd) = $_[0];
	&head;

	print "<form method=post action=$cgi_url>\n";
	print "<input type=hidden name=id value=$FORM{'id'}>\n";
	&checkbox_up;
	if($cmd eq "admin_login"){
		$msg = "ڸ  ϼ̳׿... ^^";
		$act = "admin_form";
		$admin = "";
	}
	elsif($cmd eq "delete"){
		$msg = " մϴ...";
		$act = "del_gul";
	}
	elsif($cmd eq "modify"){
		$msg = "$FORM{'no'}  մϴ...";
		$act = "modify_form";
	}
	elsif($cmd eq "hidden"){
		$msg = "  ϴ...";
		$act = "view_ok";	
		$small_opt = "<input type=hidden name=small value=ok>\n";
		$small_opt .= "<input type=hidden name=ans value=$FORM{'ans'}>\n" if($FORM{'ans'} ne "");
	}
	elsif($cmd eq "reply_hidden"){
		$msg = " ۿ 亯 ϴ...";
		$act = "reply";
		$no_opt = "<input type=hidden name=no value=$FORM{'no'}>\n";
	}

	$gul_opt = "<input type=hidden name=gul value=$FORM{'gul'}>\n" if($FORM{'gul'} ne "");	
	$ans_opt = "<input type=hidden name=ans value=$FORM{'ans'}>\n" if($FORM{'ans'} ne "");	

	print "<a href=$cgi_url?id=$FORM{'id'}&page=$page><img src=$img_url/dak.gif border=0 alt=\"۸ ư\"></a>&nbsp;<font color=$link_color>Notice!!!</font><br><br> $msg<br><br>\n";
	print "<input type=hidden name=action value=$act>\n";
	print $gul_opt;
	print $ans_opt;
	print $small_opt;
	print $no_opt;
	print "<table border=0 cellpadding=0 cellspacing=0>\n";
	print "<tr><td>$admin йȣ &nbsp;</td><td><input type=password size=10 name=admin_pwd $input_style></td><td><input type=image src=$img_url/submit.gif border=0></td></tr>";
	print "</table>\n";
	&checkbox_down;
	print "</form><br><br>\n";

	&foot;
}

sub checkbox_up{
	print <<__CHK_UP__;
	<br><br><br>
	<div align=center><table border=0width=$width bgcolor=$bgcolor cellpadding=5 cellspacing=0>
	<tr><td align=center>
__CHK_UP__
}

sub checkbox_down{
	print <<__CHK_DOWN__;
	</td></tr>
	</table>
	</div>
__CHK_DOWN__
}

sub err{
	my($result, $msg);
	$result = $_[0];
	if($result eq "id"){
		$msg = "spguest.cgi?id=<font color=red>test</font>    ּ... ^^";
	}
	elsif($result eq "blank"){
		$msg = "̸, ,  ݵ ä մϴ...";
	}
	elsif($result eq "mail"){
		$msg = "̸ ּҰ ߸Ǿ׿... ^^";
	}
	elsif($result eq "admin"){
		$msg = " йȣ ߸Ǿϴ...";
	}
	elsif($result eq "same_pwd"){
		$msg = "Ͻ йȣ ġ ʽϴ.";
	}
	elsif($result eq "not_owner"){
		$msg = "ȣ Ʋϴ... ٽѹ Ȯ ...";
	}
	elsif($result eq "keyword"){
		$msg = "˻ Ű带 Է ּ...";
	}
	else{
		$msg = "ġ  Դϴ... ";
	}
	&head;
	print "<center>\n";
	print "<br><br><a href=$cgi_url?id=$FORM{'id'}&page=$page><img src=$img_url/err.gif border=0 alt=\"۸ ư\"></a> <font color=$link_color>Error!!!</font><br><br>";
	print "$msg";
	print "<br><br><br><a href=\"javascript:history.go(-1)\">ư(BACK)</a><br><br><br>";
	print "</center>\n";
	&foot;
}

sub head{
	my($os_data, $tbl_width, $back, @html_up);
	$os_data = $ENV{'HTTP_USER_AGENT'};
	print "Content-type: text/html\n\n";
	print "<!---------------------------------------------------------------------------------->\n";
	print "<!--  Program Name - $prog_name                                     -->\n";
	print "<!--  Programer - Kim se youn (madgf\@hanmail.net)                               -->\n";
	print "<!--  Homepage - http://sepal.woorizip.com or http://www.spfamily.com           -->\n";
	print "<!--  Last Modified - 2000. 08. 22                                              -->\n";
	print "<!--                                                          made in KOREA   -->\n";
	print "<!---------------------------------------------------------------------------------->\n\n";
	print "<html>\n";
	print "<head>\n";
	print "<title>$prog_name</title>\n";	
	$font_size = ($font_size ne "") ? "$font_size" : "9pt"; 
	print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=EUC-KR\">\n";
	print "<style type='text/css'>\n";
	print "<!--\n";
	print "A:link {color:$link_color;text-decoration:none;}\n";
	print "A:visited {color:$link_color;text-decoration:none;}\n";
	print "A:active {color:$link_color;text-decoration:underline;}\n";
	print "A:hover {color:$link_color;text-decoration:underline;}\n";
	print ".ver8 {color:$font_color;font-size:8pt}\n";
	print ".ver9 {color:$font_color;font-size:$font_size}\n";
	print "p,br,body,td,select,input,form,textarea,option {font-size:$font_size;font-family:$font_kind;}\n";
	print ".cont{line-height:140%}\n" if($os_data =~ /MSIE/); #ݽ ̹϶ line-height ɼ ֱ...
	print "-->\n";
	print "</style>\n";
	print "<script language=\"JavaScript\">\n";
	print "<!--\n";
	print "	function newin(width,height,url,name) {\n";
	print "	msgWindow=window.open(url,name,'statusbar=no,scrollbars=yes,status=yes,resizable=yes,width='+width+',height='+height)\n";
	print "	}\n";
	print "//-->\n";
	print "</script>\n";
	print "</head>\n";
	if($bgimage ne ""){
		$back="background=$bgimage";
	}
	else{
		$back="bgcolor=$bgcolor";
	}
	$tbl_width = $width + 2*$margin;
	print "<body $back>\n";

	if($FORM{'small'} ne "ok"){
		print "<div align=$left_right><table border=0 width=$tbl_width cellpadding=0 cellspacing=0>\n";
		print "<tr><td width=$margin></td><td width=$width>";
		#------------------------------------------------------ κ htmlױ ֱ
		if(-e "$main_dir/up.htm"){
			open(UPDATA,"$main_dir/up.htm");
			@html_up = <UPDATA>;
			close(UPDATA);
			foreach $_(@html_up) {
				print "$_";	
			}		
		}
		#----------------------------------------------------------------
	}
	else{
		print "<br><br>\n" unless($FORM{'action'} eq "view_ok");
	}
}

sub foot {
	if($FORM{'small'} ne "ok"){
		my($skin_data, $name, $home, @skin, @html_down);
		open(SKIN,"$guest_dir/skin/$skin/$skin.txt");
		$skin_data = <SKIN>;
		close(SKIN);
		@skin = split(/\|/, "$skin_data");
		$name = $skin[2];
		$home = $skin[3];
		print "<br><center class=ver8><a href=\"http://www.spfamily.com\" target=\"_blank\"><font color=silver>Powered by sepal</font></a><font color=silver> / </font><a href=\"$home\" target=\"_blank\"><font color=silver>Designed by $name</font></a></center>\n" if($FORM{'simple'} ne "yes");
		#----------------------------------------------- غκ htmlױ ֱ
		if(-e "$main_dir/down.htm"){
			open(DOWNDATA,"$main_dir/down.htm");
			@html_down = <DOWNDATA>;
			close(DOWNDATA);
			foreach $_(@html_down) {
				print "$_";	
			}		
		}
		#----------------------------------------------------------------
		print "</td><td width=$margin>&nbsp;</td></tr>";
		print "<tr><td colspan=3 align=center><a href=$gohome target=$gohome_target><img src=$img_url/homepage.gif border=0 alt=\"Ȩ\"></a></td></tr>" if($home_btn eq "yes");
		print "</table></div>";
		print "<br><br>\n";
	}
	else{
		print "<center><form><input type=button value=\"âݱ\" onclick=\"window.close()\" style=\"background-color:#FAFAFA;border:1 solid #333333;height:20\"></center><br><br>\n";
	}
	print "</body></html>\n";
	exit;
}

sub find {
	my($start_num, $all_val, $sub_val, $name_val, $com_val, $keywd); 
	$start_num = $FORM{'start_num'} + 1000 if($FORM{'start_num'} ne "");
	$start_num = 0 if($FORM{'start_num'} eq "");
	if($all_list > 1000){
		if($FORM{'category'} eq "all"){
			$all_val = "selected";
		}
		elsif($FORM{'category'} eq "subject"){
			$sub_val = "selected";
		}
		elsif($FORM{'category'} eq "name"){
			$name_val = "selected";
		}
		elsif($FORM{'category'} eq "comment"){
			$com_val = "selected";
		}
		$keywd = "$FORM{'keyword'}";
	}
	print "<br><br>\n";
	print "<form method=post action=$cgi_url>\n";
	print "<div align=center><table border=0 cellpadding=3 cellspacing=0>\n";
	print "<tr><td><input type=hidden name=action value=search><input type=hidden name=id value=$FORM{'id'}>\n";
    print "<input type=hidden name=start_num value=$start_num>\n" if(($all_list > 1000) || ($list_cnt > 1000));
	print "<select name=category>\n";
    print "<option value=all $all_val> ü</option>\n";
    print "<option value=name $name_val> </option>\n";
    print "<option value=subject $sub_val> </option>\n";
    print "<option value=comment $com_val> </option>\n";
    print "</select></td>\n";
 	print "<td><input type=text name=keyword  value=\"$keywd\" size=15 style=\"background-color:#FFFFFF;height:21px;border:1 solid black\"></td>\n";
	print "<td><input type=image src=$img_url/search.gif border=0></td>\n";
	print "</tr>\n";
	print "</table><div>\n";
	print "</form>\n";
}

sub send_mail{
    $mail_comment =~ s/\r?\n/<br>/g;
	open (MAIL, "|$sendmail -t") || die "Can't open sendmail program!!!\n";
	print MAIL "To: $FORM{'name'}<$FORM{'mail'}>\n";
	print MAIL "From: $admin_mail\n";
	print MAIL "Subject: $mail_subject\n";
	print MAIL "Content-Type: text/html; charset=euc-kr\n";
	print MAIL "<style type=text/css>\n";
	print MAIL "a:link, a:visited, a:active { text-decoration:none; color:blue; }\n";
	print MAIL "a:hover { text-decoration:underline; color:red; }\n";
	print MAIL "td  { font-size:9pt }\n";
	print MAIL ".main {font-size:9pt}\n";
	print MAIL "</style>\n";
	print MAIL "<div align=center><table width=100% cellpadding=2 cellspacing=0 bgcolor=$link_color>\n";
	print MAIL "<tr><td align=center><font face= class=main color=#ffffff>$mail_subject</font></td></tr>\n";
	print MAIL "<tr><td>\n";	
	print MAIL "<table width=100% cellpadding=3 cellspacing=0 bgcolor=#ffffff>\n";
	print MAIL "<tr><td bgcolor=$cel_color1><font face= class=main>\n";
	print MAIL "</font></td></tr>\n";	
	print MAIL "<tr><td><br><br>\n";		
	print MAIL "<font class=main>$mail_comment<br>\n";
	print MAIL "====================================================================<br>\n";
	print MAIL "<br><br>This message form <a href=$admin_url target=_blank>$admin_url</a></font>\n";
    print MAIL "</td></tr>\n";
	print MAIL "</table>\n";
	print MAIL "</td></tr>\n";	
	print MAIL "</table></div>\n";
	close (MAIL);
}

sub lock{
	$retry = 20;
	$interbal = 0.1;
	
	local ($lockfile) = "guest.loc";

	while ($retry--){
		if(-e "$main_dir/$lockfile"){
			select (undef,undef,undef,$interbal);
		}
		else{
			open(LOCK,">$main_dir/$lockfile");
			close (LOCK);
			return 1;
		}
	}
	return 0;
}

sub unlock{
	local ($lockfile) = "guest.loc";
	unlink ("$main_dir/$lockfile");
}